<?php

class stats {

    private $pdo;
    
    static public function factory($pdo){
        $object = new stats();
        $object->pdo = $pdo; 
        return $object;
    }
    
    public function parseFile($source){
        $arr = array();
        foreach($source as $k => $row){
            if(preg_match("#\[(\d+)\]? (.+) slayed (.+) with his sword#", $row, $result)){
                $arr[$result[2]]['kills']++;
                $arr[$result[2]]['streak']++;
                $arr[$result[3]]['deaths']++; 
                
                $arr[$result[2]]['best_streak'] = $arr[$result[2]]['streak']>$arr[$result[2]]['best_streak']?$arr[$result[2]]['streak']:$arr[$result[2]]['best_streak'];
                $arr[$result[3]]['streak'] = 0;                 
            } elseif(preg_match("#\[(\d+)\]? (.+) shot (.+) with his arrow#", $row, $result)){
                $arr[$result[2]]['kills']++;
                $arr[$result[2]]['streak']++;
                $arr[$result[3]]['deaths']++;
                
                $arr[$result[2]]['best_streak'] = $arr[$result[2]]['streak']>$arr[$result[2]]['best_streak']?$arr[$result[2]]['streak']:$arr[$result[2]]['best_streak'];
                $arr[$result[3]]['streak'] = 0;                 
            } elseif(preg_match("#\[(\d+)\]? (.+) gibbed (.+) into pieces#", $row, $result)){
                $arr[$result[2]]['kills']++;
                $arr[$result[2]]['streak']++;
                $arr[$result[3]]['deaths']++; 
                
                $arr[$result[2]]['best_streak'] = $arr[$result[2]]['streak']>$arr[$result[2]]['best_streak']?$arr[$result[2]]['streak']:$arr[$result[2]]['best_streak'];
                $arr[$result[3]]['streak'] = 0; 
            } elseif(preg_match("#\[(\d+)\]? (.+) pushed (.+) to his death#", $row, $result)){
                $arr[$result[2]]['kills']++;
                $arr[$result[2]]['streak']++;
                $arr[$result[3]]['deaths']++; 
                
                $arr[$result[2]]['best_streak'] = $arr[$result[2]]['streak']>$arr[$result[2]]['best_streak']?$arr[$result[2]]['streak']:$arr[$result[2]]['best_streak'];
                $arr[$result[3]]['streak'] = 0;                 
            } elseif(preg_match("#\[(\d+)\]? (.+) died under falling rocks#", $row, $result)){
                $arr[$result[2]]['deaths']++;   
                $arr[$result[2]]['streak'] = 0;                 
            } elseif(preg_match("#\[(\d+)\]? (.+) fell on a spike trap#", $row, $result)){
                $arr[$result[2]]['deaths']++;   
                $arr[$result[2]]['streak'] = 0;      
            }          
        }
        /*
        echo '<pre>';
        var_dump($arr); 
        echo '</pre>';*/
        //die();
        return $arr;
    }
    
    public function insertStats($stats){
        foreach($stats as $k=>$s){
            $result = $this -> pdo -> query('SELECT id, streak FROM stats WHERE username="'.$k.'"') -> fetch();

            if(empty($result)){  
                $this->pdo -> exec('INSERT INTO `stats` (`username`, `kills`, `deaths`, `streak`, `last_seen`, `first_show`)   VALUES(
                                    \''.$k.'\',
                                    \''.$s['kills'].'\',
                                    \''.$s['deaths'].'\',
                                    \''.$s['best_streak'].'\',
                                      '.time().',
                                      '.time().')');
            } else {
                 $streak = $s['best_streak']>$result['streak']?$s['best_streak']:$result['streak'];
                 $this->pdo -> exec('UPDATE `stats` SET `kills`=kills+'.$s["kills"].', `deaths`=deaths+'.$s["deaths"].', `streak`='.$streak.', `deaths`=deaths+'.$s["deaths"].', `last_seen`='.time().' WHERE `username`="'.$k.'"');               
            }
        }
    } 
    
    public function getStats($offset = 0, $limit = 50, $order = 'kills', $sort = 'desc'){
        if(!in_array($order, array('username','kills','deaths','ratio','streak'))) $order = 'kills';
        if(!in_array($sort, array('desc','asc'))) $sort = 'desc';
        
        $query = 'SELECT username, kills, deaths, streak, ROUND(kills/deaths, 2) as ratio, last_seen FROM stats ORDER BY '.$order.' '.$sort.' LIMIT '.intval($offset).','.intval($limit);
        $results = $this -> pdo -> query($query) -> fetchAll();
        return $results;
    }
    
    public function getStatsSum(){
        $results = $this -> pdo -> query('SELECT SUM(kills) as kills, SUM(deaths) as deaths, COUNT(id) as players FROM stats') -> fetch();
        return $results;
    } 
    
}